<template>
  <div>
    <v-dialog v-model="mostrarAdvertencia" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div class="titSec font-size-13">Advertencia</div>
          <div class="gris">
            <div class="titCol titDialog">¿Estas seguro de eliminar el archivo?</div>
          </div>
        </div>
        <div class="btnCenter">
          <button class="btn btnG" @click="cancelarAlerta">Cancelar</button>
          <button class="btn" @click="eliminarArchivo">Aceptar</button>
        </div>
      </v-card>
    </v-dialog>

    <v-dialog v-model="mensajeAlerta.mostrarAdvertencia" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div class="titSec font-size-13">Advertencia</div>
          <div class="gris">
            <div class="titCol titDialog">{{ mensajeAlerta.mensaje }}</div>
          </div>
        </div>
        <div class="btnCenter">
          <button
            v-if="mensajeAlerta.validaCarga > 0"
            class="btn btnG"
            @click="cancelarAlerta"
          >
            {{ mensajeAlerta.btn1 }}
          </button>
          <button class="btn" @click="btn2Accion">
            {{ mensajeAlerta.btn2 }}
          </button>
        </div>
      </v-card>
    </v-dialog>
    <div class="titSec" style="padding-left: 10px">Nueva version de documento</div>
    <template>
      <div>
        <div class="blanco contSecc"></div>
        <v-card>
          <div class="gris">
            <v-row>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <v-row>
                  <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                    <v-card>
                      <div class="gris">
                        <div class="contSecc">
                          <div class="titSecCard">Datos origen de archivo</div>
                          <br />
                          <v-row>
                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Ceco</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.idCeco" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Nombre Sucursal</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="nombreSucursal" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Formato</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.nombreFormato" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Documento</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.nombreDocumento" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Proyecto</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.nombreProyecto" />
                            </v-col>
                          </v-row>
                        </div>
                      </div>
                    </v-card>
                  </v-col>
                  <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                    <v-card>
                      <div class="gris">
                        <div class="contSecc">
                          <div class="titSecCard">Propiedades del archivo</div>
                          <v-row>
                            <br />
                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Nombre de Archivo</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.nombreArchivo" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Tipo de extensión</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.extension" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Fecha</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.fecha" />
                            </v-col>

                            <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                              <div class="subtitle-2">
                                <b>Version Actual</b><span class="tRojo"></span>
                              </div>
                              <v-text-field readonly v-model="item.idVersion" />
                            </v-col>
                          </v-row>
                        </div>
                      </div>
                    </v-card>
                  </v-col>
                </v-row>
              </v-col>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <v-card>
                  <div class="gris">
                    <div class="contSecc">
                      <div class="titSecCard">Carga de archivo</div>

                      <div class="subtitle-2">
                        <b>Version siguiente: </b
                        ><span class="tRojo"
                          ><b>{{ item.idVersion + 1 }}</b></span
                        >
                        <vue-file-agent
                          :multiple="false"
                          :deletable="true"
                          :editable="false"
                          :meta="true"
                          :maxSize="'15MB'"
                          :theme="'list'"
                          :helpText="'Arrastra tu archivo aquí o selecciónalo aquí'"
                          :errorText="{
                            type: 'Formato del archivo no permitido',
                            size: 'Los archivos no pueden pasar mas de 10MB',
                          }"
                          class="upload-block"
                          :linkable="false"
                          :auto="false"
                          @upload="onUpload($event)"
                          @beforedelete="onBeforeDelete($event)"
                          @delete="onDelete($event)"
                          @select="filesSelected($event)"
                          ref="fileAgent"
                          v-model="fileRecords"
                        >
                        </vue-file-agent>
                      </div>
                    </div>
                  </div>
                </v-card>
              </v-col>
            </v-row>
          </div>
        </v-card>
      </div>
    </template>
    <div class="btnCenter">
      <button class="btn" @click="btnVersionar()">Versionar</button>
    </div>
  </div>
</template>

<style scoped>
.btnCenter {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
  margin: 20px 0;
}
.btnCenter button {
  margin: 0px 1% 10px 0px;
}
.delete {
  z-index: 11;
  float: right;
}
</style>

<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
import router from "@/router";
export default {
  name: "nuevaVersionComponent",
  props: {
    value: Object,
    itemSeleccionado: Object,
    callbackNuevaVersionComponent: { type: Function },
  },
  data() {
    return {
      nombreSucursal: "",
      user: null,

      uploadHeaders: {
        "Content-Type": "application/json",
        Authorization: "Bearer " + serviceLocalStorage.getAccessToken(),
      },

      item: {
        idCeco: 0,
        nombreFormato: "",
        nombreDocumento: "",
        nombreProyecto: "",

        nombreArchivo: "",
        extension: "",
        fecha: "",
        idVersion: 0,
      },
      fileRecords: [],
      fileRecordsForUpload: [],
      mensajeAlerta: {
        validaCarga: 0,
        mensaje: "",
        btn1: "Cancelar",
        btn2: "Aceptar",
        mostrarAdvertencia: false,
      },
      mostrarAdvertencia: false,

      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Entrega",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_entrega",
          },
        },
        {
          text: "Listado de Documentos",
          disabled: false,
          exact: true,
          to: {
            name: "infraestructura_layouts_documentos",
          },
        },
        {
          text: "Nueva version de Documentos",
          disabled: false,
          exact: false,
          to: {
            name: "",
          },
        },
      ],
    };
  },

  computed: {
    uploadUrl() {
      let value =
        store.state.urlApiPlataformaFranquicia +
        "documento-sucursal/archivos/v1/" +
        this.item.idFolio +
        "/archivos";
      return value;
    },
  },
  methods: {
    onBeforeDelete(fileRecord) {
      this.mostrarAdvertencia = true;
      this.fileRecord = fileRecord;
    },
    onDelete(fileRecord) {
      //this.$refs.fileAgent.deleteUpload(fileRecord);
      //naada
    },
    toBase64(file) {
      return new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = (error) => reject(error);
      });
    },
    onUpload(responses) {
      for (let response of responses) {
        if (response.error) {
          continue;
        }
        let data = response.data;
        if (data) {
          let uid = data.resultado.uid;
          response.fileRecord.uid = uid;
          response.fileRecord.url = this.uploadUrl + "/" + uid + "/contenido";
          this.subeArchivoVirtual(response.fileRecord);
        }
      }
    },

    async filesSelected(fileRecordsNewlySelected) {
      for (let fileRecordNewlySelected of fileRecordsNewlySelected) {
        const result = await this.toBase64(fileRecordNewlySelected.file).catch((e) =>
          Error(e)
        );
        if (result instanceof Error) {
          console.log("Error: ", result.message);
          return;
        }
        fileRecordNewlySelected.srcB64 = result;
        fileRecordNewlySelected.indice = this.fileRecords.length;
      }
      var validFileRecords = fileRecordsNewlySelected.filter(
        (fileRecord) => !fileRecord.error
      );
      this.fileRecordsForUpload = this.fileRecordsForUpload.concat(validFileRecords);
    },

    cancelarAlerta() {
      this.mostrarAdvertencia = false;
      this.mensajeAlerta.mostrarAdvertencia = false;
    },
    eliminarArchivo() {
      this.mostrarAdvertencia = false;
      this.$refs.fileAgent.deleteFileRecord(this.fileRecord);
    },

    btnVersionar() {
      this.mensajeAlerta.validaCarga = 0;
      if (this.item != null) {
        if (this.fileRecords != null && this.fileRecords.length > 0) {
          if (this.item.generaVersion == 1) {
            this.mensajeAlerta.mensaje =
              "¿Estas seguro que deseas crear esta nueva version?";
            this.mensajeAlerta.validaCarga = 1;
            this.mensajeAlerta.btn1 = "Cancelar";
            this.mensajeAlerta.btn2 = "Aceptar";
            this.mensajeAlerta.mostrarAdvertencia = true;
          } else {
            this.mensajeAlerta.mensaje =
              "¿Estas seguro que deseas crear esta nueva version?";
            this.mensajeAlerta.validaCarga = 2;
            this.mensajeAlerta.btn1 = "Cancelar";
            this.mensajeAlerta.btn2 = "Aceptar";
            this.mensajeAlerta.mostrarAdvertencia = true;
          }
        } else {
          this.mensajeAlerta.mensaje = "No has cargado el archivo";
          this.mensajeAlerta.validaCarga = -1;
          this.mensajeAlerta.btn1 = "";
          this.mensajeAlerta.btn2 = "Aceptar";
          this.mensajeAlerta.mostrarAdvertencia = true;
        }
      } else {
        this.mensajeAlerta.mensaje = "No se cuenga con informacion para cargar";
        this.mensajeAlerta.validaCarga = -1;
        this.mensajeAlerta.btn1 = "";
        this.mensajeAlerta.btn2 = "Aceptar";
        this.mensajeAlerta.mostrarAdvertencia = true;
      }
    },
    btn2Accion() {
      switch (this.mensajeAlerta.validaCarga) {
        case 1:
        case 2:
          this.subeArchivo();
          this.mensajeAlerta.mostrarAdvertencia = false;
          break;
        case -99:
          this.mensajeAlerta.mostrarAdvertencia = false;
          this.callbackNuevaVersionComponent();
          //router.push({
          //name: "infraestructura_layouts_documentos",
          //params: {},
          //});
          break;

        case -1:
        default:
          this.mensajeAlerta.mostrarAdvertencia = false;
          break;
      }
    },
    subeArchivo() {
      this.$refs.fileAgent.upload(
        this.uploadUrl,
        this.uploadHeaders,
        this.fileRecordsForUpload,
        function createFormData(fileData) {
          let srcB64 = fileData.raw.srcB64;
          srcB64 = srcB64.split(",")[1];
          var extension = fileData.file.name.split(".")[1];
          var tipoContenido = fileData.file.type;
          if (extension == "dwg" || extension == "DWG") {
            tipoContenido = "image/x-dwg";
          }
          return (
            '{"nombre":"' +
            fileData.file.name +
            '","archivo":"' +
            srcB64 +
            '", "tipoContenido": "' +
            tipoContenido +
            '"}'
          );
        }
      );
      this.fileRecordsForUpload = [];
    },
    subeArchivoVirtual(file) {
      var tipoCont = file.type;
      let idUsr = JSON.stringify(this.user.empleado);
      var idArchivoPadre = 0;
      var idVersion = 0;
      if (file.ext == "dwg" || file.ext == "DWG") {
        tipoCont = "image/x-dwg";
      }
      if (this.mensajeAlerta.validaCarga == 1) {
        idArchivoPadre = this.item.idArchivo;
        idVersion = this.item.idVersion + 1;
      }

      const body = {
        uid: file.uid,
        nombre: file.name(),
        descripcion: file.name(),
        peso: file.size,
        extension: file.ext,
        tipo: this.type,
        tipoContenido: tipoCont,
        indice: file.indice,
        usuarioCreador: idUsr,
        idVersion: idVersion,
        idArchivoPadre: idArchivoPadre,
      };
      const self = this;
      if (this.mensajeAlerta.validaCarga == 1) {
        axios
          .post(
            "/documento-sucursal/virtuales-archivos/v1/" +
              this.item.idFolio +
              "/virtuales/archivos",
            body
          )
          .then((response) => {
            let data = response.data;
            if (data) {
              //file.idArchivo = data.resultado.id;
              this.insertaRelacion(data.resultado.id);
            }
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          });
      }
      if (this.mensajeAlerta.validaCarga == 2) {
        axios
          .put(
            "/documento-sucursal/virtuales-archivos/v1/" +
              this.item.idFolio +
              "/virtuales/archivos/" +
              this.item.idArchivo,
            body
          )
          .then((response) => {
            let data = response.data;
            if (data) {
              //file.idArchivo = data.resultado.id;
              this.mensajeAlerta.mostrarAdvertencia = true;
              this.mensajeAlerta.btn2 = "Aceptar";
              this.mensajeAlerta.mensaje = "Archivo actualizado.....";
              this.mensajeAlerta.validaCarga = -99;
            }
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          });
      }
    },
    insertaRelacion(idArchivoCargado) {
      console.log("insertaRelacion");
      axios
        .post("/documento-sucursal/documentoArchivo/v1/", {
          folio: this.item.idFolio,
          idDocumento: this.item.idDocumento,
          idArchivo: idArchivoCargado,
        })
        .then((response) => {
          let data = response.data;
          if (data) {
            this.mensajeAlerta.mostrarAdvertencia = true;
            this.mensajeAlerta.btn2 = "Aceptar";
            this.mensajeAlerta.mensaje = "Archivo actualizado.....";
            this.mensajeAlerta.validaCarga = -99;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
  created() {
    this.user = serviceLocalStorage.userToken();
  },
  mounted() {
    this.item = this.itemSeleccionado;
    if (this.value.dataCeco.value.descripcion) {
      this.nombreSucursal = this.value.dataCeco.value.descripcion;
    } else {
      this.nombreSucursal = this.value.dataCeco.ceco;
    }
  },
};
</script>
